<?php

function draw_pagenumbers($startpage,$entries,$entries_per_page,$page_uri,$varname) {
	$startpage = intval($startpage);
	$entries   = intval($entries);

	if ($entries_per_page <= 0) $entries_per_page = 25;

	$last = $entries % $entries_per_page;
	$max_page =  (int)($entries / $entries_per_page);
	if ($last > 0) $max_page++;	 // max. Anzahl von Seiten
	$prepages = $startpage-1;
	if ($prepages > 5) $prepages = 5;
	$followpages = 10-1-$prepages;
	if ($followpages > 9) $followpages = 9;
	if (($followpages + $startpage) > $max_page) $followpages = $max_page - $startpage;
	if (($prepages + $followpages + 1) < $max_page) $prepages = 10 - $followpages - 1;
	if ($prepages >= $startpage) $prepages = $startpage - 1; // neu

	$endpage = $startpage+$followpages;
	$urlbind = strpos($page_uri,"?"); // Schauen ob schon Variablen angeh�ngt sind
	if ($urlbind === FALSE) {
		$urlbind = "?";
	} else {
		$urlbind = "&amp;";
	}
	// pagelink generieren
	$page_uri  = str_replace($urlbind.$varname."=".$startpage,"",$page_uri);

	// < und << davorsetzen
	if ((($startpage - 10) <= 0) && ($startpage > 2)) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=1\">&lt;&lt;</a>&nbsp;";
	} elseif ((($startpage - 10) > 0)) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".($startpage-10)."\">&lt;&lt;</a>&nbsp;";
	}
	if ($startpage > 1) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".($startpage-1)."\">&lt;</a>&nbsp;";
	}

	// Seitennummern inkl. pagelink ausgeben
	$pagenumber = $startpage - $prepages;
	while ($pagenumber <= $endpage) {
		if ($pagenumber != $startpage) {
			echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".$pagenumber."\">$pagenumber</a>&nbsp;";
		} else {
			echo "<span class=\"currentpage\">".$pagenumber."&nbsp;</span>";
		}
		$pagenumber++;
	}

	// > und >> dahintersetzen
	if ($startpage < $max_page) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".($startpage+1)."\">&gt;</a>&nbsp;";
	}
	if ((($startpage + 10) >= $max_page) && ($startpage+1 < $max_page)) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".$max_page."\">&gt;&gt;</a>&nbsp;";
	} elseif ((($startpage + 10) < $max_page)) {
		echo "<a class=\"pagelink\" href=\"".$page_uri.$urlbind.$varname."=".($startpage+10)."\">&gt;&gt;</a>&nbsp;";
	}


}



function makeheader($title) {
	global $global_universe, $allyhistory, $playerhistory;
	@include "../languages/korean_workaround.inc.php";

	// styles path holen
	if (isset($_SESSION['s_stylepath'])) $stylepath = $_SESSION['s_stylepath'];
	if (trim($stylepath) == "") $stylepath = "styles.css";

	$tmp = strrpos($stylepath,"/");
	$modname = "EpicBlue";
	if ($tmp !== false) {
		$tmp = substr($stylepath,0,$tmp);
		$pos = strrpos($tmp,"/");
		if ($pos !== false) $modname = substr($tmp,$pos+1,strlen($tmp)-$pos);
	}


	echo '
	<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
	<html>
	<head>
	<meta http-equiv="content-type" content="text/html; charset=UTF-8">
	<title>'.$title.'</title>
	<link rel="stylesheet" type="text/css" href="'.$stylepath.'" />
	<script type="text/javascript" src="advajax.js"></script>
	<script type="text/javascript" src="common_scripts.js"></script>
	<script type="text/javascript" src="galaxytool.js"></script>
	<script type="text/javascript" src="tab_plugin.js"></script>
	<script type="text/javascript" src="pop_up.js"></script>
	<script type="text/javascript" src="js_tablesort/common.js"></script>
	<script type="text/javascript" src="js_tablesort/css.js"></script>
	<script type="text/javascript" src="js_tablesort/standardista-table-sorting.js"></script>
	</head>';
	if ($title == VIEW_TITLE) {
		echo '<body onKeyDown="cursorevent(event);" onload="Init()">';
	} elseif (isset($_GET['action']) && $_GET['action'] == "searchres" && isset($_POST[urlencode(REPORTS_SEARCH_EXTENDED)])) {
	    echo "<body>";
	} else {
		echo '<body onload="Init()">';
	}

	// for timeout issues
	echo '<iframe src="session.php" style="display:none; position:absolute; top:0px; left:0px; height:0px; width:0px">';
	echo '</iframe>';

	echo '
	<table cellspacing="0" cellpadding="0" style="width:930px;" border="0" class="frameset">
	  <tr>
	    <td valign="top" style="width:172px;">
		<div class="copyright" style="width:120px; margin-left:26px; margin-top:26px;" align="center">'.SHORTNAME.'<br><a href="index.php?versionscheck" class="pagelink">'.VERSION.'</a><br>';
	// --------------------------------- BEGIN OF INFORMATION BLOCK ---------------------------------------------
	if (!empty($global_universe) && is_numeric($global_universe)) echo '<span class="mod">'.UNIVERSE.' '.$global_universe.'</span><br>';
	echo '<span class="mod">'.$modname.'-Mod</span></div>
	    <table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    <tr><td class="tblhead">'.MENU_INFO_LINKS.'</td></tr>
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="index.php">'.MENU_PAGE.'</a></td></tr>'."\n";
	if ($_SESSION['s_cansearch']) {
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="show.php">'.MENU_DB_SEARCH.'</a></td></tr>'."\n";
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="notices.php?action=search">'.MENU_DB_NOTICES.'</a></td></tr>'."\n";
	}
	if ($_SESSION['s_probeview']) echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="reports.php?action=search">'.MENU_DB_REPORTS.'</a></td></tr>'."\n";
	if ($_SESSION['s_cansearch']) {
		if (isset($_SESSION['s_gv_galaxy']) && isset($_SESSION['s_gv_system']))
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="view.php?gala='.$_SESSION['s_gv_galaxy'].'&amp;system='.$_SESSION['s_gv_system'].'">'.MENU_GALAXYVIEW.'</a></td></tr>'."\n";
		else
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="view.php?gala=1&amp;system=1">'.MENU_GALAXYVIEW.'</a></td></tr>'."\n";
	}

	echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="stats.php">'.MENU_STATISTICS.'</a></td></tr>'."\n";
	if (($_SESSION['s_allyhistory'] === true) && (!empty($allyhistory) || !empty($playerhistory))) {
	   echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="allyhistory.php">'.MENU_ALLYHISTORY.'</a></td></tr>'."\n";
	}

	echo "</table>";

	// --------------------------------- END OF INFORMATION BLOCK ---------------------------------------------


	// --------------------------------- BEGIN OF OPTION BLOCK ---------------------------------------------
	echo '<table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
    	  <tr><td class="tblhead">'.MENU_OPTION_LINKS.'</td></tr>';

	if ($_SESSION['s_caninsert']) echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="einlesen.php">'.MENU_DB_REFRESH.'</a></td></tr>'."\n";

	if ($_SESSION['s_statusview']) {
		echo '    <tr class="firstcolor"><td class="menu"><a class="menulink" href="status.php">'.MENU_DB_STATUS.'</a></td></tr>'."\n";
	}

	if ($_SESSION['s_userman']) {
		echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="usermanagement.php">'.MENU_USEROPTIONS.'</a></td></tr>'."\n";
		echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="userinfo.php">'.MENU_USEROPTIONS3.'</a></td></tr>'."\n";
	}
	echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="change_password.php">'.MENU_USEROPTIONS2.'</a></td></tr>'."\n";
	if ($_SESSION['s_isadmin'] == true) {
		echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="administration.php">'.MENU_ADMIN.'</a></td></tr>'."\n";		
	}

	// --------------------------------- END OF OPTION BLOCK ---------------------------------------------

	// --------------------------------- BEGIN OF STUFF BLOCK ---------------------------------------------
	echo '
	    </table>
	    <table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    <tr><td class="tblhead">'.MENU_STUFF.'</td></tr>
	    ';
	switch ($_SESSION['lang']) {
		case "german" :
			$help_url = "http://de.wiki.galaxytool.eu/";
			$download_url = "http://de.wiki.galaxytool.eu/index.php/Downloads";
			break;
		case "spanish" :
			$help_url = "http://www.galaxytool.eu/spanish/about.php";
			$download_url = "http://www.galaxytool.eu/spanish/download.php";
			break;

		default:
			$help_url = "http://www.galaxytool.eu/english/about.php";
			$download_url = "http://www.galaxytool.eu/english/download.php";
			break;
	}


	echo '
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="'.$help_url.'" target="_blank">'.MENU_HELP.'</a></td></tr>
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="http://forum.mathe-informatik.de/index.php" target="_blank">'.MENU_FORUM_THREAD.'</a></td></tr>
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="'.$download_url.'" target="_blank">'.MENU_DOWNLOADPAGE.'</a></td></tr>'."\n";

	if (isset($_SESSION['s_global_links'])) {
		foreach($_SESSION['s_global_links'] as $link) {
			if (!isset($link[1])) {
				echo '
	    		</table>
	    		<table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    		<tr><td class="tblhead">'.$link[0].'</td></tr>';

			} else {
				echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="'.$link[1].'" target="_blank">'.$link[0].'</a></td></tr>'."\n";
			}
		}
	}

	if (isset($_SESSION['s_additional_links'])) {
		foreach($_SESSION['s_additional_links'] as $link) {
			if (!isset($link[1])) {
				echo '
	    		</table>
	    		<table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    		<tr><td class="tblhead">'.$link[0].'</td></tr>';

			} else {
				echo '<tr class="firstcolor"><td class="menu"><a class="menulink" href="'.$link[1].'" target="_blank">'.$link[0].'</a></td></tr>'."\n";
			}
		}
	}

	echo '
	    </table>
	    <table class="menu" cellspacing="1" cellpadding="1" width="100%" border="0">
	    <tr><td class="tblhead">'.MENU_LANGUAGE.'</td></tr>
	    <tr class="firstcolor"><td align="center">
	    <form action="index.php" method="GET">
	    <select class="pulldown_code" name="language">
          <option value="german">Deutsch</option>
          <option value="english">English</option>
          <option value="spanish">Español</option>
          <option value="dutch">Nederlands</option>
          <option value="balkan">Balkan</option>
          <option value="french">Français</option>
          <option value="portugues">Português</option>
          <option value="polish">Polish</option>
          <option value="italian">Italian</option>
          <option value="turkish">Turkish</option>
          <option value="danish">Danish</option>
          <option value="brazilian">Brazilian</option>
          <option value="russian">Russian</option>
          <option value="swedish">Swedish</option>
          <option value="greek">Greek</option>
          <option value="romanian">Romanian</option>
          <option value="hungarian">Hungarian</option>
          <option value="czech">Czech</option>
          <option value="korean">'.$korean.'</option>
          </select>&nbsp;
          <input class="button" type="submit" name="OK" value="OK" />
          </form>
          </td></tr>
	    <tr class="firstcolor"><td class="menu"><a class="menulink" href="../index.php?logout">Logout</a></td></tr>
	    </table>';
	@include "../hosting/left_menu.php";
	echo '
	    </td>
	    <td valign="top" class="mainframe" style="width:628px;">
	    ';
	@include "../hosting/mainframe_top.php";
	// --------------------------------- END OF STUFF BLOCK ---------------------------------------------
}


function makefooter() {
	@include "../hosting/mainframe_bottom.php";
	echo '
	    </td>
	    <td style=" padding-top:50px;width:130px;">&nbsp;</td>
	  </tr>
	</table>
	<div style="position:absolute; top:50px; left:10px; display: none; z-index: 999" id="popup" ></div>
	<script type="text/javascript" src="wz_tooltip.js"></script>
	</body>
	</html>';
}


/**
 * This function will check every status and print the letters given as parameters instead. This makes
 * sure that every language will get it's corresponding letter for the status.
 *
 * @param boolean $statusstring Angabe ob es als BB Code ausgegeben werden soll, oder nicht
 * @param string $statusstring
 * @param char(1) $printbanned the letter which shall be shown for banned players
 * @param char(1) $printvaction the letter which shall be shown for players at vacation mode
 * @param char(1) $printnoob the letter which shall be shown for noob players
 * @param char(1) $printinactive the letter which shall be shown for inactive players
 * @param char(1) $printlonginactive the letter which shall be shown for long inactive players
 */
function print_status($show_as_bb_code, $statusstring, $printbanned="g", $printvaction="u", $printnoob="n", $printinactive="i", $printlonginactive="I") {

	if ($show_as_bb_code) {
		if (strpos($statusstring,"g") !== false) {
			echo "[COLOR=".$_SESSION['s_bb_banned']."]".$printbanned."[/COLOR]";
		}
		if (strpos($statusstring,"u") !== false) {
			echo "[COLOR=".$_SESSION['s_bb_vacation']."]".$printvaction."[/COLOR]";
		}
		if (strpos($statusstring,"n") !== false) {
			echo "[COLOR=".$_SESSION['s_bb_noob']."]".$printnoob."[/COLOR]";
		}
		if (strpos($statusstring,"i") !== false) {
			echo "[COLOR=".$_SESSION['s_bb_inactive']."]".$printinactive."[/COLOR]";
		}
		if (strpos($statusstring,"I") !== false) {
			echo "[COLOR=".$_SESSION['s_bb_longinactive']."]".$printlonginactive."[/COLOR]";
		}

	} else {

		if (strpos($statusstring,"g") !== false) {
			echo "<span class=\"banned\">$printbanned</span>";
		}
		if (strpos($statusstring,"u") !== false) {
			echo "<span class=\"vacation\">$printvaction</span>";
		}
		if (strpos($statusstring,"n") !== false) {
			echo "<span class=\"noob\">$printnoob</span>";
		}
		if (strpos($statusstring,"i") !== false) {
			echo "<span class=\"longinactive\">$printinactive</span>";
		}
		if (strpos($statusstring,"I") !== false) {
			echo "<span class=\"inactive\">$printlonginactive</span>";
		}
	}
}

function update_speedsim_link($link,$key,$value) {
	if (empty($link)) $link = "http://websim.speedsim.net/?";
	//?ship_d0_3_b=4&tech_a0_0=10&tech_d0_1=12&engine_0=10&ship_d0_18_b=1&engine0_0=10&enemy_metal=10.000
	if ($value > 0 || $key == "coordinates") {
		switch ($key) {
			case "coordinates": $link .= "enemy_pos=$value&amp;"; break;
			case "enemy_name":  $link .= "enemy_name=$value&amp;"; break;

			case "metal":      $link .= "enemy_metal=$value&amp;"; break;
			case "crystal":    $link .= "enemy_crystal=$value&amp;"; break;
			case "deuterium":  $link .= "enemy_deut=$value&amp;"; break;

			case "kt":         $link .= "ship_d0_0_b=$value&amp;"; break;
			case "gt":         $link .= "ship_d0_1_b=$value&amp;"; break;
			case "lj":         $link .= "ship_d0_2_b=$value&amp;"; break;
			case "sj":         $link .= "ship_d0_3_b=$value&amp;"; break;
			case "krz":        $link .= "ship_d0_4_b=$value&amp;"; break;
			case "ss":         $link .= "ship_d0_5_b=$value&amp;"; break;
			case "kolo":       $link .= "ship_d0_6_b=$value&amp;"; break;
			case "rec":        $link .= "ship_d0_7_b=$value&amp;"; break;
			case "spio":       $link .= "ship_d0_8_b=$value&amp;"; break;
			case "bomb":       $link .= "ship_d0_9_b=$value&amp;"; break;
			case "sat":        $link .= "ship_d0_10_b=$value&amp;"; break;
			case "zerri":      $link .= "ship_d0_11_b=$value&amp;"; break;
			case "ds": 		   $link .= "ship_d0_12_b=$value&amp;"; break;
			case "skrz": 	   $link .= "ship_d0_13_b=$value&amp;"; break;

			case "rak": 	   $link .= "ship_d0_14_b=$value&amp;"; break;
			case "ll": 		   $link .= "ship_d0_15_b=$value&amp;"; break;
			case "sl": 		   $link .= "ship_d0_16_b=$value&amp;"; break;
			case "gauss": 	   $link .= "ship_d0_17_b=$value&amp;"; break;
			case "ion": 	   $link .= "ship_d0_18_b=$value&amp;"; break;
			case "plasma": 	   $link .= "ship_d0_19_b=$value&amp;"; break;
			case "ksk": 	   $link .= "ship_d0_20_b=$value&amp;"; break;
			case "gsk": 	   $link .= "ship_d0_21_b=$value&amp;"; break;

			case "waffentech": $link .= "tech_d0_0=$value&amp;"; break;
			case "schildtech": $link .= "tech_d0_1=$value&amp;"; break;
			case "rpz": 	   $link .= "tech_d0_2=$value&amp;"; break;

		}
		
		if ($_SESSION['s_vbt'] > 0) {
			$link .= "engine0_0=".$_SESSION['s_vbt']."&amp;";
		}
		if ($_SESSION['s_impulse'] > 0) {
			$link .= "engine0_1=".$_SESSION['s_impulse']."&amp;";
		}
		if ($_SESSION['s_hra'] > 0) {
			$link .= "engine0_2=".$_SESSION['s_hra']."&amp;";
		}
		
		if ($_SESSION['s_waffentech'] > 0) {
			$link .= "tech_a0_0=".$_SESSION['s_waffentech']."&amp;";
		}
		if ($_SESSION['s_schildtech'] > 0) {
			$link .= "tech_a0_1=".$_SESSION['s_schildtech']."&amp;";
		}
		if ($_SESSION['s_rpz'] > 0) {
			$link .= "tech_a0_2=".$_SESSION['s_rpz']."&amp;";
		}
		
	}
	return $link;
}



function get_phalanx_range($moon_array) {
	ksort($moon_array); // sort array by galaxy key
	$range_array = array();

	foreach ($moon_array as $galaxy => $values) {
		usort($values,"compare_moon_array");
		$phalanx_string[$galaxy] = "";
		$biggest_max_system = 0;
	
		for ($i=0;$i<count($values);$i++) {
			if ($biggest_max_system == 0) {
				$phalanx_string[$galaxy] .= $galaxy.":".$values[$i]['min']." - ";
			} else {
				if ($biggest_max_system < ($values[$i]['min']-1)) { // -1 to have 1:211 - 1:343 + 1:344 - 1:452 like 1:211 - 1:452
					$phalanx_string[$galaxy] .= $galaxy.":$biggest_max_system + $galaxy:".$values[$i]['min']." - ";
				}
			}
			if ($biggest_max_system < $values[$i]['max']) {
				$biggest_max_system = $values[$i]['max'];
			}

			if ($i == count($values) - 1) { // last entry
				$phalanx_string[$galaxy] .= $galaxy.":".$biggest_max_system;
			}
		}
	}

	return $phalanx_string;
}


function compare_moon_array($a, $b) {
	if ($a["min"] == $b["min"]) {
		return 0;
	}
	return ($a["min"] < $b["min"]) ? -1 : 1;
}

?>
